<?php
/**
 * Function to import MAXMIND CSV
 */
function wpgeoip_add_log($action, $message) {
	global $wpdb;
	$action = $wpdb->escape($action);
	$message = $wpdb->escape($message);
	$wpdb->query("INSERT INTO wpgeoip_log VALUES (null, '$action', '$message')");
}
function wpgeoip_import() {
global $wpdb;
$dbPrefix = $wpdb->prefix;
?>
<div id="wrap">

	<h2>Import GEOIP CSV</h2>

	<p>
		First Step is to Download the <strong>MAXMIND GeoLite Country</strong> (<strong>CSV format, not binary one</strong>):
		<br/>
		directly <a href="http://geolite.maxmind.com/download/geoip/database/GeoIPCountryCSV.zip"> <strong>GeoIPCountryCSV.zip</strong></a> or <a href="http://www.maxmind.com/app/geolitecountry" target="_blank"><strong>here to navigate their site</strong></a>
	</p>
	<p>After you have downloaded, unpack the archive and place it in the same folder as the PLUGIN.</p>

	<?php

	$filename = "GeoIPCountryWhois.csv";

	$filepath = WP_PLUGIN_DIR . "/wp-geoip-redirect/";

	$error_msg = "";
	$message = "";
	$dependent = 1;

	if (!ereg('/$', $filepath)) { $filepath = $filepath . "/";
	}

	if (ini_get('safe_mode')) {

		$error_msg .= "Warning Safe Mode PHP Server Option is ON, please turn Safe Mode OFF to avoid the app timing out before fully executing and installing the GeoIP database.<br>";
		$dependent = 0;
		
		wpgeoip_add_log('Install', $error_msg);
	} else {

		set_time_limit(0);

		if (!file_exists($filepath . $filename)) {
			$error_msg .= "The Maxmind GeoLite Country CSV file could not be found !<br>";
			$error_msg .= "Please check the file is located at " . $filepath . " of your server and the filename to be <b>\"" . $filename . "\"</b><br>";
			$dependent = 0;
			wpgeoip_add_log('Install', $error_msg);
		} else {
			$lines = count(file($filepath . $filename));
			$filesize = round(((filesize($filepath . $filename) / 1024) / 1024), 2);
			$filectime = filectime($filepath . $filename);
			$filemtime = filemtime($filepath . $filename);
			$fileatime = fileatime($filepath . $filename);
		}
	}

	function getDBstatus() {
		global $Config;
		global $lines;
		global $wpdb;
		$dbPrefix = $wpdb -> prefix;

		$result = mysql_query("SHOW TABLE STATUS LIKE '" . $dbPrefix . "ip'");
		if ($ip = mysql_fetch_array($result)) {

			if ($ip["Rows"] > ($lines - 3)) {
				return "OK";
			} else {
				return "UPDATE";
			}
		} else {
			return "CREATE";
		}
	}

	function loadCSVData($filename) {
		global $Config;
		global $message;
		global $wpdb;
		$dbPrefix = $wpdb -> prefix;

		$query = "DROP TABLE IF EXISTS `" . $dbPrefix . "csv`";
		if (!$result = mysql_query($query)) {
			$message .= "Failed to delete the `" . $dbPrefix . "csv` table!<br>";
			return false;
		}

		$query = "CREATE TABLE IF NOT EXISTS `" . $dbPrefix . "csv` (
`start_ip` char(15)NOT NULL,
`end_ip` char(15)NOT NULL,
`start` int(10) unsigned NOT NULL,
`end` int(10) unsigned NOT NULL,
`cc` char(2) NOT NULL,
`cn` varchar(50) NOT NULL
) DEFAULT CHARSET=utf8";
		if (!$result = mysql_query($query)) {
			$message .= "Failed to create the `" . $dbPrefix . "csv` table, Please check you have permission to create tables.<br>";
			wpgeoip_add_log('Install', $message . '<br/>' . mysql_error());
			return false;
		}

		$query = "LOAD DATA LOCAL INFILE \"" . $filename . "\"

INTO TABLE `" . $dbPrefix . "csv`
FIELDS
TERMINATED BY \",\"
ENCLOSED BY \"\\\"\"
LINES
TERMINATED BY \"\\n\"
(
start_ip, end_ip, start, end, cc, cn
)";
		if (!$result = mysql_query($query)) {
			$message .= "Failed to load the Maxmind CSV file into the `" . $dbPrefix . "csv` table.<br>";
			wpgeoip_add_log('Install', $message . '<br/>' . mysql_error());
			return false;
		}

		return true;
	}

	function buildGeoData() {
		global $Config;
		global $message;
		global $wpdb;
		$dbPrefix = $wpdb -> prefix;

		$query = "DROP TABLE IF EXISTS `" . $dbPrefix . "cc`";
		if (!$result = mysql_query($query)) {
			$message .= "Failed to delete the `" . $dbPrefix . "cc` table!<br>";
			wpgeoip_add_log('Install', $message . '<br/>' . mysql_error());
			return false;
		}

		$query = "CREATE TABLE IF NOT EXISTS `" . $dbPrefix . "cc` (
`ci` tinyint(3) unsigned NOT NULL auto_increment,
`cc` char(2) NOT NULL,
`cn` varchar(50) NOT NULL,
PRIMARY KEY (`ci`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;";
		if (!$result = mysql_query($query)) {
			$message .= "Failed to create the `" . $dbPrefix . "cc` table, Please check you have permission to create tables.<br>";
			wpgeoip_add_log('Install', $message . '<br/>' . mysql_error());
			return false;
		}

		$query = "DROP TABLE IF EXISTS `" . $dbPrefix . "ip`";
		// DELETE
		if (!$result = mysql_query($query)) {
			$message .= "Failed to delete the `" . $dbPrefix . "csv` table!<br>";
			wpgeoip_add_log('Install', $message . '<br/>' . mysql_error());
			return false;
		}

		$query = "CREATE TABLE IF NOT EXISTS `" . $dbPrefix . "ip` (
`start` int(10) unsigned NOT NULL,
`end` int(10) unsigned NOT NULL,
`ci` tinyint(3) unsigned NOT NULL,
KEY `start` (`start`),
KEY `end` (`end`)
)  DEFAULT CHARSET=utf8;";
		if (!$result = mysql_query($query)) {
			$message .= "Failed to create the `" . $dbPrefix . "ip` table!<br>";
			wpgeoip_add_log('Install', $message . '<br/>' . mysql_error());
			return false;
		}

		$query = "INSERT INTO `" . $dbPrefix . "cc` SELECT DISTINCT NULL, `cc`, `cn` FROM `" . $dbPrefix . "csv`;";
		if (!$result = mysql_query($query)) {
			$message .= "Failed to insert data into the `" . $dbPrefix . "cc` table from the `" . $dbPrefix . "csv` table!<br>";
			return false;
			wpgeoip_add_log('Install', $message . '<br/>' . mysql_error());
		}

		$query = "INSERT INTO `" . $dbPrefix . "ip` SELECT `start`, `end`, `ci` FROM `" . $dbPrefix . "csv` NATURAL JOIN `" . $dbPrefix . "cc`;";
		if (!$result = mysql_query($query)) {
			$message .= "Failed to insert data into the `" . $dbPrefix . "ip` table from the `" . $dbPrefix . "csv` table!<br>";
			wpgeoip_add_log('Install', $message . '<br/>' . mysql_error());
			return false;
		}

		return true;
	}

	function deleteData() {
		global $Config;
		global $message;
		global $wpdb;
		$dbPrefix = $wpdb -> prefix;

		$query = "DROP TABLE IF EXISTS `" . $dbPrefix . "csv`";
		// DELETE
		if (!$result = mysql_query($query)) {
			$message .= "Failed to delete the `" . $dbPrefix . "csv` table!<br>";
			wpgeoip_add_log('Install', $message . '<br/>' . mysql_error());
			return false;
		}
		return true;
	}

	if (isset($_REQUEST["action"]) && $_REQUEST["action"] == "cancel") {
		print "<meta http-equiv=\"refresh\" content=\"0;url=http://" . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'] . "?page=wpgeoip-admin-import\">";
		exit ;
	}

	if ($dependent == 0) {
		$error_msg .= "Please correct the script before continuing !<br>";
	} else {

		if (!isset($_REQUEST["action"])) {
			$message .= "<b>Current Maxmind GeoIP CSV data according to your CSV File</b><br>";
			$message .= "Total of " . $lines . " Records <br>";
			$message .= "Filesize is " . $filesize . " MegaBytes<br>";
			$message .= "Created on " . date("D j M Y", $filectime) . "<br>";

			switch (getDBstatus()) {
				case "OK" :
					$message .= "Update NOW - <a href=?action=update>Re-Import CSV</a><br>";
					$message .= "<strong>The GeoIP database is fully up to date !</strong><br>";
					break;
				case "UPDATE" :
					$message .= "A newer version of DB was scanned !<br>";
					$message .= "Would you like to update the GeoIP database ? ";
					$message .= "<a href=\"http://" . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'] . "?page=wpgeoip-admin-import&action=update\">yes</a><br>";
					break;
				case "CREATE" :
					$message .= "The script could not detect a GeoIP country database<br>";
					$message .= "Would you like to create a new GeoIP database ? ";
					$message .= "<a href=\"http://" . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'] . "?page=wpgeoip-admin-import&action=create\">yes</a><br>";
					break;
			}
		}

		if (isset($_REQUEST["action"]) && $_REQUEST["action"] == "create" && !isset($_REQUEST["confirm"])) {
			$message .= "Note : Updating the GeoIP database can take up to a few minutes depending on you server.<br>";
			$message .= "After you click 'yes' please be patient.<br>";
			$message .= "Are you sure you would like to create the database ? ";
			$message .= "<a href=\"http://" . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'] . "?page=wpgeoip-admin-import&action=create&confirm=yes\">yes</a> / ";
			$message .= "<a href=\"http://" . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'] . "?page=wpgeoip-admin-import&action=cancel\">cancel</a><br>";
		}

		if (isset($_REQUEST["action"]) && $_REQUEST["action"] == "update" && !isset($_REQUEST["confirm"])) {
			$message .= "Note : Updating the GeoIP database can take up to a few minutes depending on you server.<br>";
			$message .= "After you click 'yes' please be patient.<br>";
			$message .= "Are you sure you would like to update the database ? ";
			$message .= "<a href=\"http://" . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'] . "?page=wpgeoip-admin-import&action=update&confirm=yes\">yes</a> / ";
			$message .= "<a href=\"http://" . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'] . "?page=wpgeoip-admin-import&action=cancel\">cancel</a><br>";
		}

		if (isset($_REQUEST["action"]) && $_REQUEST["action"] == "create" && isset($_REQUEST["confirm"]) && $_REQUEST["confirm"] == "yes") {
			if (loadCSVData($filepath . $filename)) {
				if (buildGeoData()) {
					if (deleteData()) {
						print "<meta http-equiv=\"refresh\" content=\"0;url=http://" . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'] . "?page=wpgeoip-admin-import\">";
						exit ;
					}
				}
			}
		}

		if (isset($_REQUEST["action"]) && $_REQUEST["action"] == "update" && isset($_REQUEST["confirm"]) && $_REQUEST["confirm"] == "yes") {
			if (loadCSVData($filename)) {
				if (buildGeoData()) {
					if (deleteData()) {
						print "<meta http-equiv=\"refresh\" content=\"0;url=http://" . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'] . "?page=wpgeoip-admin-import\">";
						exit ;
					}
				}
			}
		}
	}
?>

	<?php

	if ($error_msg != "") {
		print '<div class="error">' . $error_msg . '</div>';
	} else {
		print '<div class="updated bellow-h2">Please check WPGeoIP Log' . $message . '</div>';
	}
?>
</div><!--wrap-->

<?php } ?>